import { AudioFlag } from './enums';
import { Entity } from './models';
import { Vector3 } from './utils';
export declare abstract class Audio {
    static PlaySoundAt(position: Vector3, sound: string, set?: string): number;
    static PlaySoundFromEntity(entity: Entity, sound: string, set?: string): number;
    static PlaySoundFrontEnd(sound: string, set?: string): number;
    static StopSound(soundId: number): void;
    static ReleaseSound(soundId: number): void;
    static HasSoundFinished(soundId: number): boolean;
    static SetAudioFlag(flag: string | AudioFlag, toggle: boolean): void;
    static PlaySound(soundFile: string, soundSet: string): void;
    static PlayMusic(musicFile: string): void;
    static StopMusic(musicFile: string): void;
    private static readonly audioFlags;
}
