import { CameraShake } from './enums';
import { Entity } from './models';
import { Vector3 } from './utils';
export declare class Camera {
    private readonly shakeNames;
    private handle;
    constructor(handle: number);
    IsActive: boolean;
    Position: Vector3;
    Rotation: Vector3;
    Direction: Vector3;
    readonly ForwardVector: Vector3;
    FieldOfView: number;
    NearClip: number;
    FarClip: number;
    NearDepthOfField: number;
    FarDepthOfField: number;
    DepthOfFieldStrength: number;
    MotionBlurStrength: number;
    Shake(shakeType: CameraShake, amplitude: number): void;
    StopShaking(): void;
    readonly IsShaking: boolean;
    ShakeAmplitude: number;
    PointAt(entity: Entity, offset?: Vector3): void;
    StopPointing(): void;
    InterpTo(to: Camera, duration: number, easePosition: boolean, easeRotation: boolean): void;
    readonly IsInterpolating: boolean;
    AttachTo(entity: Entity, offset: Vector3): void;
    Detach(): void;
    Delete(): void;
    Exists(): boolean;
}
