"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
/**
 * The current rendering gameplay camera
 */
class GameplayCamera {
    static get Position() {
        const coords = GetGameplayCamCoords();
        return new utils_1.Vector3(coords[0], coords[1], coords[2]);
    }
    static get Rotation() {
        const rot = GetGameplayCamRot(2);
        return new utils_1.Vector3(rot[0], rot[1], rot[2]);
    }
    static get ForwardVector() {
        const rotation = utils_1.Vector3.Multiply(this.Rotation, Math.PI / 180);
        const normalized = utils_1.Vector3.Normalize(new utils_1.Vector3(-Math.sin(rotation.z) * Math.abs(Math.cos(rotation.x)), Math.cos(rotation.z) * Math.abs(Math.cos(rotation.x)), Math.sin(rotation.x)));
        return new utils_1.Vector3(normalized.x, normalized.y, normalized.z);
    }
    static get RelativePitch() {
        return GetGameplayCamRelativePitch();
    }
    static set RelativePitch(pitch) {
        SetGameplayCamRelativePitch(pitch, 1);
    }
    get RelativeHeading() {
        return GetGameplayCamRelativeHeading();
    }
    set RelativeHeading(heading) {
        SetGameplayCamRelativeHeading(heading);
    }
}
exports.GameplayCamera = GameplayCamera;
