import { ParticleEffectAsset } from './';
import { InvertAxis } from './enums';
import { Color } from './utils';
import { Vector3 } from './utils';
export declare abstract class ParticleEffect {
    protected readonly asset: ParticleEffectAsset;
    protected readonly effectName: string;
    protected offset: Vector3;
    protected rotation: Vector3;
    protected color: Color;
    protected scale: number;
    protected range: number;
    protected invertAxis: InvertAxis;
    private handle;
    constructor(asset: ParticleEffectAsset, effectName: string);
    readonly Handle: number;
    readonly IsActive: boolean;
    abstract Start(): boolean;
    Stop(): void;
    Rotation: Vector3;
    Range: number;
    InvertAxis: InvertAxis;
    SetParameter(parameterName: string, value: number): void;
    readonly AssetName: string;
    readonly EffectName: string;
    ToString(): string;
}
