"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// TODO: Lots of Matrix stuff through memory access
class ParticleEffect {
    constructor(asset, effectName) {
        this.handle = -1;
        this.asset = asset;
        this.effectName = effectName;
    }
    get Handle() {
        return this.handle;
    }
    get IsActive() {
        return this.Handle !== -1 && !!DoesParticleFxLoopedExist(this.Handle);
    }
    Stop() {
        if (this.IsActive) {
            RemoveParticleFx(this.Handle, false);
        }
        this.handle = -1;
    }
    get Rotation() {
        return this.rotation;
    }
    set Rotation(rotation) {
        this.rotation = rotation;
        if (this.IsActive) {
            const off = this.offset; // TODO Matrix stuff to access from memory
            SetParticleFxLoopedOffsets(this.Handle, off.x, off.y, off.z, rotation.x, rotation.y, rotation.z);
        }
    }
    get Range() {
        return this.range;
    }
    set Range(range) {
        this.range = range;
        SetParticleFxLoopedRange(this.Handle, range);
    }
    get InvertAxis() {
        return this.invertAxis;
    }
    set InvertAxis(invertAxis) {
        this.invertAxis = invertAxis;
        if (this.IsActive) {
            this.Stop();
            this.Start();
        }
    }
    SetParameter(parameterName, value) {
        if (this.IsActive) {
            SetParticleFxLoopedEvolution(this.Handle, parameterName, value, false);
        }
    }
    get AssetName() {
        return this.asset.AssetName;
    }
    get EffectName() {
        return this.effectName;
    }
    ToString() {
        return `${this.AssetName}\\${this.EffectName}`;
    }
}
exports.ParticleEffect = ParticleEffect;
