"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Game_1 = require("./Game");
const utils_1 = require("./utils");
class RaycastResult {
    get HitEntity() {
        return this.entityHandleArg;
    }
    get HitPosition() {
        return this.hitPositionArg;
    }
    get SurfaceNormal() {
        return this.surfaceNormalArg;
    }
    get DidHit() {
        return this.hitSomethingArg;
    }
    get DidHitEntity() {
        return this.entityHandleArg.Handle !== 0;
    }
    get Material() {
        return this.materialArg;
    }
    get Result() {
        return this.result;
    }
    constructor(handle) {
        this.handle = handle;
        this.hitPositionArg = new utils_1.Vector3(0, 0, 0);
        this.hitSomethingArg = false;
        this.entityHandleArg = null;
        this.surfaceNormalArg = new utils_1.Vector3(0, 0, 0);
        this.materialArg = 0;
        const results = GetShapeTestResultEx(this.handle);
        this.hitSomethingArg = !!results[1];
        this.hitPositionArg = new utils_1.Vector3(results[2][0], results[2][1], results[2][2]);
        this.surfaceNormalArg = new utils_1.Vector3(results[3][0], results[3][1], results[3][2]);
        this.materialArg = results[4];
        this.entityHandleArg = Game_1.Game.EntityFromHandle(results[5]);
        this.result = results[0];
    }
}
exports.RaycastResult = RaycastResult;
