import { Vector3 } from '../';
import { DrivingStyle, HelmetType, RagdollType, SpeechModifier, VehicleSeat } from '../enums';
import { WeaponHash } from '../hashes';
import { Entity } from './';
import { Vehicle } from './';
export declare class Ped extends Entity {
    static Exists(ped: Ped): boolean;
    private readonly speechModifierNames;
    constructor(handle: number);
    readonly CurrentVehicle: Vehicle;
    readonly LastVehicle: Vehicle;
    readonly VehicleTryingToEnter: Vehicle;
    DrivingStyle: DrivingStyle;
    IsInAnyVehicle(): boolean;
    IsInVehicle(vehicle: Vehicle): boolean;
    IsSittingInAnyVehicle(): boolean;
    IsSittingInVehicle(vehicle: Vehicle): boolean;
    SetIntoVehicle(vehicle: Vehicle, seat: VehicleSeat): void;
    Kill(): void;
    Resurrect(): void;
    ResetVisibleDamage(): void;
    ClearBloodDamage(): void;
    readonly IsInGroup: boolean;
    NeverLeavesGroup: boolean;
    LeaveGroup(): void;
    PlayAmbientSpeed(speechName: string, voiceName?: string, modifier?: SpeechModifier): void;
    ApplyDamage(damageAmount: number): void;
    HasBeenDamagedBy(weapon: WeaponHash): boolean;
    HasBeenDamagedByAnyWeapon(): boolean;
    HasBeenDamagedByAnyMeleeWeapon(): boolean;
    ClearLastWeaponDamage(): void;
    GetLastWeaponImpactPosition(): Vector3;
    CanRagdoll: boolean;
    Ragdoll(duration?: number, ragdollType?: RagdollType): void;
    CancelRagdoll(): void;
    GiveHelmet(canBeRemovedByPed: boolean, helmetType: HelmetType, textureIndex: number): void;
    RemoveHelmet(instantly: boolean): void;
    OpenParachute(): void;
    GetConfigFlag(flagId: number): boolean;
    SetConfigFlag(flagId: number, value: boolean): void;
    ResetConfigFlag(flagId: number): void;
    Clone(heading: number): Ped;
    Exists(): boolean;
}
