"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const _1 = require("./");
const _2 = require("./");
class Container extends _1.Rectangle {
    constructor(pos, size, color) {
        super(pos, size, color);
        this.Items = [];
    }
    addItem(item) {
        this.Items.push(item);
    }
    Draw(offset) {
        if (!this.enabled) {
            return;
        }
        offset = offset || new utils_1.Size();
        const height = _2.Screen.Height;
        const width = _2.Screen.ScaledWidth;
        const w = this.size.Width / width;
        const h = this.size.Height / height;
        const x = (this.pos.X + offset.Width) / width + w * 0.5;
        const y = (this.pos.Y + offset.Height) / height + h * 0.5;
        DrawRect(x, y, w, h, this.color.r, this.color.g, this.color.b, this.color.a);
        for (const item of this.Items) {
            item.Draw(new utils_1.Size(this.pos.X + offset.Width, this.pos.Y + offset.Height));
        }
    }
}
exports.Container = Container;
