"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enums_1 = require("../enums");
class Hud {
    static IsComponentActive(component) {
        return !!IsHudComponentActive(Number(component));
    }
    static ShowComponentThisFrame(component) {
        ShowHudComponentThisFrame(Number(component));
    }
    static HideComponentThisFrame(component) {
        HideHudComponentThisFrame(Number(component));
    }
    static ShowCursorThisFrame() {
        ShowCursorThisFrame();
    }
    static get CursorSprite() {
        return enums_1.CursorSprite.DownArrow;
    }
    static set CursorSprite(sprite) {
        SetCursorSprite(Number(sprite));
    }
    static get IsVisible() {
        return !(IsHudHidden() || !IsHudPreferenceSwitchedOn());
    }
    static set IsVisible(toggle) {
        DisplayHud(toggle);
    }
    static get IsRadarVisible() {
        return !(IsRadarHidden() || IsRadarPreferenceSwitchedOn());
    }
    static set IsRadarVisible(toggle) {
        DisplayRadar(toggle);
    }
    static set RadarZoom(zoomLevel) {
        SetRadarZoom(zoomLevel);
    }
}
exports.Hud = Hud;
