"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enums_1 = require("../enums");
class LoadingPrompt {
    static Show(loadingText = null, spinnerType = enums_1.LoadingSpinnerType.RegularClockwise) {
        if (this.IsActive) {
            this.Hide();
        }
        if (loadingText === null) {
            BeginTextCommandBusyString(null);
        }
        else {
            BeginTextCommandBusyString('STRING');
            AddTextComponentSubstringPlayerName(loadingText);
        }
        EndTextCommandBusyString(Number(spinnerType));
    }
    static Hide() {
        if (this.IsActive) {
            RemoveLoadingPrompt();
        }
    }
    static get IsActive() {
        return !!IsLoadingPromptBeingDisplayed();
    }
}
exports.LoadingPrompt = LoadingPrompt;
