"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const _1 = require("./");
const interfaces_1 = require("./interfaces");
class Rectangle extends interfaces_1.IElement {
    constructor(pos, size, color) {
        super();
        this.enabled = true;
        this.pos = pos;
        this.size = size;
        this.color = color;
    }
    Draw(pos, size, color) {
        if (!pos) {
            pos = new utils_1.Size(0, 0);
        }
        if (!size && !color) {
            pos = new utils_1.Point(this.pos.X + pos.Width, this.pos.Y + pos.Height);
            size = this.size;
            color = this.color;
        }
        const height = _1.Screen.Height;
        const width = _1.Screen.ScaledWidth;
        const w = size.Width / width;
        const h = size.Height / height;
        const x = pos.X / width;
        const y = pos.Y / height;
        DrawRect(x, y, w, h, color.r, color.g, color.b, color.a);
    }
}
exports.Rectangle = Rectangle;
