"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const _1 = require("./");
const interfaces_1 = require("./interfaces");
const modules_1 = require("./menu/modules");
class Text extends interfaces_1.IElement {
    constructor(caption, pos, scale, color, font, centered) {
        super();
        this.caption = caption;
        this.pos = pos;
        this.scale = scale;
        this.color = color || utils_1.Color.Black;
        this.font = font || 0;
        this.centered = centered || false;
    }
    Draw(caption, pos, scale, color, font, centered) {
        if (caption && !pos && !scale && !color && !font && !centered) {
            pos = new utils_1.Point(this.pos.X + caption.Width, this.pos.Y + caption.Height);
            scale = this.scale;
            color = this.color;
            font = this.font;
            centered = this.centered;
        }
        const x = pos.X / _1.Screen.ScaledWidth;
        const y = pos.Y / _1.Screen.Height;
        SetTextFont(Number(font));
        SetTextScale(scale, scale);
        SetTextColour(color.r, color.g, color.b, color.a);
        SetTextCentre(centered);
        SetTextEntry('STRING');
        modules_1.ResText.AddLongString(caption);
        DrawText(x, y);
    }
}
exports.Text = Text;
exports = Text;
