import { LiteEvent, Size } from '../../utils';
import { UIMenuCheckboxItem, UIMenuItem, UIMenuListItem, UIMenuSliderItem } from './items';
export declare class Menu {
    readonly Id: string;
    ParentMenu: Menu;
    ParentItem: UIMenuItem;
    Children: Map<string, Menu>;
    WidthOffset: number;
    Visible: boolean;
    MouseControlsEnabled: boolean;
    AUDIO_LIBRARY: string;
    AUDIO_UPDOWN: string;
    AUDIO_LEFTRIGHT: string;
    AUDIO_SELECT: string;
    AUDIO_BACK: string;
    AUDIO_ERROR: string;
    MenuItems: Array<UIMenuItem | UIMenuListItem | UIMenuSliderItem | UIMenuCheckboxItem>;
    CurrentSelection: number;
    readonly IndexChange: LiteEvent;
    readonly ListChange: LiteEvent;
    readonly SliderChange: LiteEvent;
    readonly SliderSelect: LiteEvent;
    readonly CheckboxChange: LiteEvent;
    readonly ItemSelect: LiteEvent;
    readonly MenuOpen: LiteEvent;
    readonly MenuClose: LiteEvent;
    readonly MenuChange: LiteEvent;
    private title;
    private subtitle;
    private counterPretext;
    private counterOverride;
    private spriteLibrary;
    private spriteName;
    private offset;
    private lastUpDownNavigation;
    private lastLeftRightNavigation;
    private activeItem;
    private extraOffset;
    private justOpened;
    private safezoneOffset;
    private MaxItemsOnScreen;
    private minItem;
    private maxItem;
    private MouseEdgeEnabled;
    private readonly mainMenu;
    private readonly logo;
    private readonly upAndDownSprite;
    private readonly titleResText;
    private readonly subtitleResText;
    private readonly extraRectangleUp;
    private readonly extraRectangleDown;
    private readonly descriptionBar;
    private readonly descriptionRectangle;
    private readonly descriptionText;
    private readonly counterText;
    private readonly background;
    constructor(title: any, subtitle: any, offset: any, spriteLibrary?: any, spriteName?: any);
    SetMenuWidthOffset(widthOffset: number): void;
    AddItem(item: UIMenuItem): void;
    RefreshIndex(): void;
    Clear(): void;
    Open(): void;
    Close(): void;
    Subtitle: string;
    GoLeft(): void;
    GoRight(): void;
    SelectItem(): void;
    GetScreenResolutionMantainRatio(): Size;
    ProcessControl(): void;
    GoUpOverflow(): void;
    GoUp(): void;
    GoDownOverflow(): void;
    GoDown(): void;
    GoBack(): void;
    BindMenuToItem(menuToBind: Menu, itemToBindTo: UIMenuItem): void;
    ReleaseMenuFromItem(releaseFrom: UIMenuItem): boolean;
    private RecalculateDescriptionPosition;
    private FormatDescription;
    private render;
}
