"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("../../");
const utils_1 = require("../../../utils");
const _1 = require("./");
class UIMenuCheckboxItem extends _1.UIMenuItem {
    constructor(text, check = false, description = '') {
        super(text, description);
        this.Checked = false;
        this.OnCheckedChanged = new utils_1.LiteEvent();
        const y = 0;
        this.checkedSprite = new __1.Sprite('commonmenu', 'shop_box_blank', new utils_1.Point(410, y + 95), new utils_1.Size(50, 50));
        this.Checked = check;
    }
    get CheckedChanged() {
        return this.OnCheckedChanged.expose();
    }
    SetVerticalPosition(y) {
        super.SetVerticalPosition(y);
        this.checkedSprite.pos = new utils_1.Point(380 + this.Offset.X + this.Parent.WidthOffset, y + 138 + this.Offset.Y);
    }
    Draw() {
        super.Draw();
        this.checkedSprite.pos = this.checkedSprite.pos = new utils_1.Point(380 + this.Offset.X + this.Parent.WidthOffset, this.checkedSprite.pos.Y);
        const isDefaultHightlitedForeColor = this.HighlightedForeColor === _1.UIMenuItem.DefaultHighlightedForeColor;
        if (this.Selected && isDefaultHightlitedForeColor) {
            this.checkedSprite.textureName = this.Checked ? 'shop_box_tickb' : 'shop_box_blankb';
        }
        else {
            this.checkedSprite.textureName = this.Checked ? 'shop_box_tick' : 'shop_box_blank';
        }
        this.checkedSprite.color = this.Enabled
            ? this.Selected && !isDefaultHightlitedForeColor
                ? this.HighlightedForeColor
                : this.ForeColor
            : new utils_1.Color(255, 163, 159, 148);
        this.checkedSprite.Draw();
    }
    SetRightBadge(badge) {
        return this;
    }
    SetRightLabel(text) {
        return this;
    }
}
exports.UIMenuCheckboxItem = UIMenuCheckboxItem;
