import { Menu } from '../';
import { Sprite } from '../../';
import { BadgeStyle } from '../../../enums';
import { Color, Point } from '../../../utils';
import { ResRectangle, ResText } from '../modules/';
export declare class UIMenuItem {
    static readonly DefaultBackColor: Color;
    static readonly DefaultHighlightedBackColor: Color;
    static readonly DefaultForeColor: Color;
    static readonly DefaultHighlightedForeColor: Color;
    readonly Id: string;
    BackColor: Color;
    HighlightedBackColor: Color;
    ForeColor: Color;
    HighlightedForeColor: Color;
    Enabled: boolean;
    Selected: boolean;
    Hovered: boolean;
    Description: string;
    Offset: Point;
    Parent: Menu;
    RightLabel: string;
    LeftBadge: BadgeStyle;
    RightBadge: BadgeStyle;
    protected rectangle: ResRectangle;
    protected text: ResText;
    protected selectedSprite: Sprite;
    protected badgeLeft: Sprite;
    protected badgeRight: Sprite;
    protected labelText: ResText;
    private event;
    Text: string;
    constructor(text: any, description?: string);
    SetVerticalPosition(y: number): void;
    addEvent(event: string, ...args: any[]): void;
    fireEvent(): void;
    Draw(): void;
    SetLeftBadge(badge: BadgeStyle): void;
    SetRightBadge(badge: BadgeStyle): void;
    SetRightLabel(text: string): void;
    BadgeToSpriteLib(badge: BadgeStyle): string;
    BadgeToSpriteName(badge: BadgeStyle, selected: boolean): string;
    IsBagdeWhiteSprite(badge: BadgeStyle): boolean;
    BadgeToColor(badge: BadgeStyle, selected: boolean): Color;
}
