"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("../../");
const utils_1 = require("../../../utils/");
const modules_1 = require("../modules/");
const _1 = require("./");
class UIMenuSliderItem extends _1.UIMenuItem {
    get Index() {
        return this.index % this.items.length;
    }
    set Index(value) {
        this.index = 100000000 - (100000000 % this.items.length) + value;
    }
    constructor(text, items, index, description = '', divider = false) {
        super(text, description);
        const y = 0;
        this.items = items;
        this.arrowLeft = new __1.Sprite('commonmenutu', 'arrowleft', new utils_1.Point(0, 105 + y), new utils_1.Size(15, 15));
        this.arrowRight = new __1.Sprite('commonmenutu', 'arrowright', new utils_1.Point(0, 105 + y), new utils_1.Size(15, 15));
        this.rectangleBackground = new modules_1.ResRectangle(new utils_1.Point(0, 0), new utils_1.Size(150, 9), new utils_1.Color(255, 4, 32, 57));
        this.rectangleSlider = new modules_1.ResRectangle(new utils_1.Point(0, 0), new utils_1.Size(75, 9), new utils_1.Color(255, 57, 116, 200));
        if (divider) {
            this.rectangleDivider = new modules_1.ResRectangle(new utils_1.Point(0, 0), new utils_1.Size(2.5, 20), utils_1.Color.WhiteSmoke);
        }
        else {
            this.rectangleDivider = new modules_1.ResRectangle(new utils_1.Point(0, 0), new utils_1.Size(2.5, 20), utils_1.Color.Transparent);
        }
        this.Index = index;
    }
    SetVerticalPosition(y) {
        this.rectangleBackground.pos = new utils_1.Point(250 + this.Offset.X + this.Parent.WidthOffset, y + 158.5 + this.Offset.Y);
        this.rectangleSlider.pos = new utils_1.Point(250 + this.Offset.X + this.Parent.WidthOffset, y + 158.5 + this.Offset.Y);
        this.rectangleDivider.pos = new utils_1.Point(323.5 + this.Offset.X + this.Parent.WidthOffset, y + 153 + this.Offset.Y);
        this.arrowLeft.pos = new utils_1.Point(235 + this.Offset.X + this.Parent.WidthOffset, 155.5 + y + this.Offset.Y);
        this.arrowRight.pos = new utils_1.Point(400 + this.Offset.X + this.Parent.WidthOffset, 155.5 + y + this.Offset.Y);
        super.SetVerticalPosition(y);
    }
    IndexToItem(index) {
        return this.items[index];
    }
    Draw() {
        super.Draw();
        this.arrowLeft.color = this.Enabled
            ? this.Selected
                ? utils_1.Color.Black
                : utils_1.Color.WhiteSmoke
            : new utils_1.Color(255, 163, 159, 148);
        this.arrowRight.color = this.Enabled
            ? this.Selected
                ? utils_1.Color.Black
                : utils_1.Color.WhiteSmoke
            : new utils_1.Color(255, 163, 159, 148);
        const offset = ((this.rectangleBackground.size.Width - this.rectangleSlider.size.Width) / (this.items.length - 1)) * this.Index;
        this.rectangleSlider.pos = new utils_1.Point(250 + this.Offset.X + offset + +this.Parent.WidthOffset, this.rectangleSlider.pos.Y);
        if (this.Selected) {
            this.arrowLeft.Draw();
            this.arrowRight.Draw();
        }
        this.rectangleBackground.Draw();
        this.rectangleSlider.Draw();
        this.rectangleDivider.Draw();
    }
    SetRightBadge(badge) { }
    SetRightLabel(text) { }
}
exports.UIMenuSliderItem = UIMenuSliderItem;
