export interface IVec3 {
    x: number;
    y: number;
    z: number;
}
export declare class Vector3 implements IVec3 {
    x: number;
    y: number;
    z: number;
    static Create(v1: IVec3): Vector3;
    static Clone(v1: IVec3): Vector3;
    static Add(v1: IVec3, v2: IVec3): Vector3;
    static Subtract(v1: IVec3, v2: IVec3): Vector3;
    static Multiply(v1: IVec3, v2: IVec3 | number): Vector3;
    static Divide(v1: IVec3, v2: IVec3 | number): Vector3;
    static DotProduct(v1: IVec3, v2: IVec3): number;
    static CrossProduct(v1: IVec3, v2: IVec3): Vector3;
    static Normalize(v: Vector3): Vector3;
    constructor(x: number, y: number, z: number);
    clone(): Vector3;
    DistanceSquared(v: IVec3): number;
    Normalize(v: IVec3): Vector3;
    CrossProduct(v: IVec3): Vector3;
    Add(v: IVec3): IVec3;
    Subtract(v: IVec3): Vector3;
    Multiply(v: IVec3 | number): Vector3;
    Divide(v: IVec3): IVec3;
    Replace(v: IVec3): void;
}
